import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:http/http.dart' as http;
import 'package:likewallet_connection/animationPage.dart';
import 'package:likewallet_connection/complete.dart';
import 'package:likewallet_connection/likewallet_connection.dart';
import 'package:likewallet_connection/otp_send.dart';
import 'package:modal_progress_hud/modal_progress_hud.dart';

import 'dart:math';
import 'package:encrypt/encrypt.dart' as Encrypt;

class OTP_PAGE extends StatefulWidget {
//  OTP_PAGE({this.checkIf});
  OTP_PAGE(
      {this.phoneNumber,
      this.secret,
      this.idcard,
      this.firstName,
      this.lastName,
      this.register,
        this.exitPage,
        this.application
      });

  final String phoneNumber;
  final String secret;
  final String idcard;
  final String firstName;
  final String lastName;
  final String register;
  final exitPage;
  final String application;

//  final FirebaseAuth auth;
//  final String verificationId;
//  final VoidCallback onSignedIn;

//  OTP_PAGE({Key key, @required this.text}) : super(key: key);
  @override
  _OTP_PAGE createState() => new _OTP_PAGE(
      phoneNumber: phoneNumber,
      firstName: firstName,
      lastName: lastName,
      idcard: idcard,
      secret: secret,
      register: register,
      exitPage: exitPage,
      application: application
  );
}

enum FormType { login, register }

class _OTP_PAGE extends State<OTP_PAGE> {
  _OTP_PAGE(
      {this.phoneNumber,
        this.secret,
        this.idcard,
        this.firstName,
        this.lastName,
        this.register,
        this.exitPage,
        this.application
      });

  final String phoneNumber;
  final String secret;
  final String idcard;
  final String firstName;
  final String lastName;
  final String register;
  final String application;
  final exitPage;
  String keyEncrypt;
  String ivEncrypt;
  int checkRound = 0;
  List<String> otp = List<String>();

  Future<bool> sendCodeToPhoneNumber(_phoneNumberController, dropdownValue) async {
    String url =  'http:///authNoFirebase';
    var response = await http.post(url, body: {'phone_number': _phoneNumberController});
    print('Response status: ${response.statusCode}');
    print('Response body: ${response.body}');
    var body = json.decode(response.body);

    if (body['statusCode'] == 200) {
      //success register and sign in
      //to confirm

      return true;
    } else {
      return false;
    }
  }

  static const chars = "abcdefghijklmnopqrstuvwxyz0123456789";

  String RandomString(int strlen) {
    Random rnd = new Random(new DateTime.now().millisecondsSinceEpoch);
    String result = "";
    for (var i = 0; i < strlen; i++) {
      result += chars[rnd.nextInt(chars.length)];
    }
    return result;
  }
  getIv() async {
     keyEncrypt = RandomString(32);
     ivEncrypt = RandomString(16);
  }
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    getIv();
    verifyOTP = OTPManagement();


  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
  }

  final formKey = new GlobalKey<FormState>();

  String _email;
  String _password;
  FormType _formType = FormType.login;
  int numberPhone = 0;
  String dropdownValue;
//  FirebaseAuth _auth = FirebaseAuth.instance;
  int passCodeColo = 0;
  String passCode = '';
  bool _saving = false;

  SendOTP verifyOTP;
  bool validateAndSave() {
    final form = formKey.currentState;
    if (form.validate()) {
      form.save();
      return true;
    } else {
      return false;
    }
  }

  void setCode(pass) {
    if (pass.toString() == 'remove') {
      setState(() {
        if (passCodeColo <= 0) {
          passCodeColo = 0;
          passCode = '';
        } else {
          passCodeColo -= 1;
          passCode = passCode.substring(0, passCode.length - 1);
          setState(() {
            otp.removeLast();
          });
        }
      });
    } else {
      setState(() {
        if (passCodeColo > 6) {
          passCodeColo = 6;
        } else {
          passCodeColo += 1;
        }

        passCode += pass.toString();
        setState(() {
          otp.add(pass.toString());
        });
      });
    }
    print(passCode);
    if (passCodeColo == 6) {
      //login
      setState(() {
        _saving = true;
      });

      verifyOTP.verifyOTPMessage(
          smsCode: passCode.trim(),
          phoneNumber: phoneNumber,
          lastName: lastName,
          firstName: firstName,
          idcard: idcard,
          register: register,
          secret: secret,
          ivEncrypt: ivEncrypt,
          keyEncrypt: keyEncrypt,
          application: application
      ).then((value) {
        setState(() {
          _saving = false;
        });
        if (value) {
          //ไปหน้าสำเร็จ
          Navigator.push(
              context,
              EnterExitRoute(
                  exitPage: exitPage,
                  enterPage: CompleteTX(title: 'สำเร็จ !',
                    buttonText: 'กลับหน้าแรก',
                    back: exitPage,
                    detail: 'ท่านได้เข้าสู่ระบบ Likewallet เรียบร้อย',)
              )
          );
        }
      });
    }
  }


  reSend() {
    if (checkRound < 1) {
      checkRound = 1;
      setState(() {
        _saving = true;
      });
      //send again
      verifyOTP.sendOTPMessage(phoneNumber: phoneNumber).then((data) {
        setState(() {
          _saving = false;
        });
      });
    }
  }


  gridviewForPhone(Orientation orientation) {
    return new Scaffold(
      resizeToAvoidBottomInset: false,
      resizeToAvoidBottomPadding: false,
      backgroundColor: Color(0xff13D7C8),
      body: new Stack(
//          width: double.infinity,
        alignment: Alignment.bottomCenter,
        children: <Widget>[
          new Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisSize: MainAxisSize.max,
            children: <Widget>[
              new Padding(
                padding: EdgeInsets.only(
                    top: MediaQuery.of(context).size.width * 0.2),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: <Widget>[
                    new Text(
                      'ยังไม่ได้รับ SMS ใช่ไหม ?',
                      style: TextStyle(
                          color: Color(0xff000000),
                          fontFamily: 'Proxima Nova',
                          fontSize: MediaQuery.of(context).size.height *
                              0.01724137931),
                    ),
                    SizedBox(
                      width: MediaQuery.of(context).size.width * 0.02,
                    ),
                    ButtonTheme(
                      minWidth: MediaQuery.of(context).size.width * 0.1,
                      height: MediaQuery.of(context).size.height * 0.0369458128,
                      child: checkRound == 0
                          ? new FlatButton(
                          shape: new RoundedRectangleBorder(
                            borderRadius: new BorderRadius.circular(5.0),
                          ),
                          disabledColor: Color(0xff000000),
                          color: Color(0xff000000),
                          onPressed: () {
                            reSend();
                          },
                          child: new Text(
                            'ส่งอีกครั้ง',
                            style: TextStyle(
                                fontFamily: 'Proxima Nova',
                                color: Colors.white,
                                fontSize:
                                MediaQuery.of(context).size.height *
                                    0.01600985221,
                                fontWeight: FontWeight.normal),
                          ))
                          : new FlatButton(
                          shape: new RoundedRectangleBorder(
                            borderRadius: new BorderRadius.circular(5.0),
                          ),
                          disabledColor: Color(0xff000000).withOpacity(0.2),
                          color: Color(0xff000000).withOpacity(0.2),
                          child: new Text(
                            'ส่งอีกครั้ง',
                            style: TextStyle(
                                fontFamily: 'Proxima Nova',
                                color: Colors.white.withOpacity(0.2),
                                fontSize:
                                MediaQuery.of(context).size.height *
                                    0.01600985221,
                                fontWeight: FontWeight.normal),
                          )),
                    ),
                  ],
                ),
              ),
              new Padding(
                padding: EdgeInsets.only(
                    top: MediaQuery.of(context).size.height * 0.1),
                child: new Text(
                 'ใส่รหัส OTP',
                  style: TextStyle(
                      color: Color(0xff000000).withOpacity(0.7),
                      fontFamily:
                      'otp_code',
                      fontWeight: FontWeight.bold,
                      fontSize:
                      MediaQuery.of(context).size.height * 0.02586206896),
                ),
              ),
              new Container(
                  padding: EdgeInsets.only(
                      top: MediaQuery.of(context).size.width * 0.03),
                  child: new Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: <Widget>[
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.002),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 0
                                ? Text('')
                                : Text(
                              otp[0],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 0
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.002),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 1
                                ? Text('')
                                : Text(
                              otp[1],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 1
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.002),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 2
                                ? Text('')
                                : Text(
                              otp[2],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 2
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.001),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 3
                                ? Text('')
                                : Text(
                              otp[3],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 2
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.002),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 4
                                ? Text('')
                                : Text(
                              otp[4],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 4
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(
                            MediaQuery.of(context).size.height * 0.002),
                        child: new Container(
                          width: MediaQuery.of(context).size.height * 0.05,
                          height: MediaQuery.of(context).size.height * 0.05,
                          child: new Align(
                            alignment: Alignment.center,
                            child: passCodeColo <= 5
                                ? Text('')
                                : Text(
                              otp[5],
                              style: TextStyle(
                                  fontSize:
                                  MediaQuery.of(context).size.height *
                                      0.01923076923,
                                  fontWeight: FontWeight.normal,
                                  color: Colors.white),
                            ),
                          ),
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 5
                                ? Color(0xff10C4BC)
                                : Color(0xff10C4BC),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                    ],
                  )),
            ],
          ),
          new Container(
            padding:
            EdgeInsets.only(top: MediaQuery.of(context).size.height * 0.1),
            child: new Container(
              width: MediaQuery.of(context).size.width * 0.75,
//                  padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.05),
              child: new Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  for (var a = 0; a < 3; a++)
                    new Row(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: <Widget>[
                        for (var i = 1; i <= 3; i++)
                          if (a == 0)
                            new Expanded(
//                                  padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.02),
                                child: Column(
                                  children: <Widget>[
                                    new FlatButton(
                                      onPressed: () => setCode(i),
                                      child: new Text(
                                        i.toString(),
                                        style: TextStyle(
                                            fontSize:
                                            MediaQuery.of(context).size.height *
                                                0.04556650246,
                                            fontFamily: 'Nimbus Sans',
                                            fontWeight: FontWeight.normal),
                                      ),
                                    ),
                                    SizedBox(
                                        height: MediaQuery.of(context).size.height *
                                            0.02)
                                  ],
                                ))
                          else if (a == 1)
                            new Expanded(
//                                  padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.02),
                                child: Column(
                                  children: <Widget>[
                                    new FlatButton(
                                      onPressed: () => setCode(i + 3),
                                      child: new Text(
                                        (i + 3).toString(),
                                        style: TextStyle(
                                            fontSize:
                                            MediaQuery.of(context).size.height *
                                                0.04556650246,
                                            fontFamily: 'Nimbus Sans',
                                            fontWeight: FontWeight.normal),
                                      ),
                                    ),
                                    SizedBox(
                                        height: MediaQuery.of(context).size.height *
                                            0.02)
                                  ],
                                ))
                          else if (a == 2)
                              new Expanded(
//                                    padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.02),
                                  child: Column(
                                    children: <Widget>[
                                      new FlatButton(
                                        onPressed: () => setCode(i + 6),
                                        child: new Text(
                                          (i + 6).toString(),
                                          style: TextStyle(
                                              fontSize:
                                              MediaQuery.of(context).size.height *
                                                  0.04556650246,
                                              fontFamily: 'Nimbus Sans',
                                              fontWeight: FontWeight.normal),
                                        ),
                                      ),
                                      SizedBox(
                                          height: MediaQuery.of(context).size.height *
                                              0.02)
                                    ],
                                  ))
                      ],
                    ),
                  new Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: <Widget>[
                      new Expanded(
//                            padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.02),
                          child: new FlatButton(
                            onPressed: () => setCode(0),
                            child: new Text(''),
                          )),
                      new Expanded(
//                            padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.02),
                          child: new FlatButton(
                            onPressed: () => setCode(0),
                            child: new Text(
                              '0',
                              style: TextStyle(
                                  fontSize: MediaQuery.of(context).size.height *
                                      0.04556650246,
                                  fontFamily: 'Nimbus Sans',
                                  fontWeight: FontWeight.normal),
                            ),
                          )),
                      new Expanded(
//                            padding: EdgeInsets.all(MediaQuery.of(context).size.width * 0.01),
                          child: new FlatButton(
                              onPressed: () => setCode('remove'),
                              child: new Icon(
                                Icons.backspace,
                                size: MediaQuery.of(context).size.height *
                                    0.04556650246,
                              )))
                    ],
                  )
                ],
              ),
            ),
          )
        ],
      ),
    );
  }

  gridviewForTablet(Orientation orientation) {
    return new Scaffold(
      resizeToAvoidBottomInset: false,
      resizeToAvoidBottomPadding: false,
      backgroundColor: Color(0xff13D7C8),
      body: new Container(
          width: double.infinity,
          alignment: Alignment.bottomCenter,
          child: new Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisSize: MainAxisSize.max,
            children: <Widget>[
              new Padding(
                padding: EdgeInsets.only(
                    top: MediaQuery.of(context).size.width * 0.2),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: <Widget>[
                    new Text(
                      'Didn’t get the code?    ',
                      style:
                      TextStyle(color: Color(0xff000000), fontSize: 28.0),
                    ),
                    ButtonTheme(
                      minWidth: MediaQuery.of(context).size.width * 0.1,
                      height: MediaQuery.of(context).size.width * 0.07,
                      child: new FlatButton(
                          shape: new RoundedRectangleBorder(
                            borderRadius: new BorderRadius.circular(5.0),
                          ),
                          disabledColor: Color(0xff000000),
                          color: Color(0xff000000),
                          onPressed: () => {
//
                          },
                          child: new Text(
                            'Resend',
                            style: TextStyle(
                                fontSize: 28,
                                color: Colors.white,
                                fontWeight: FontWeight.normal),
                          )),
                    ),
                  ],
                ),
              ),
              new Padding(
                padding: EdgeInsets.only(
                    top: MediaQuery.of(context).size.width * 0.15),
                child: new Text(
                  'Enter Your Passcode',
                  style: TextStyle(color: Color(0xff5B5E5C), fontSize: 28.0),
                ),
              ),
              new Padding(
                  padding: EdgeInsets.only(
                      top: MediaQuery.of(context).size.width * 0.03),
                  child: new Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: <Widget>[
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo == 0
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 1
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 2
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 3
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 4
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                      new Padding(
                        padding: EdgeInsets.all(2.0),
                        child: new Container(
                          width: MediaQuery.of(context).size.width * 0.05,
                          height: MediaQuery.of(context).size.width * 0.05,
                          decoration: new BoxDecoration(
                            color: passCodeColo <= 5
                                ? Colors.white
                                : Color(0xff3C3C3C),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ),
                    ],
                  )),
              new Padding(
                padding: EdgeInsets.only(
                    top: MediaQuery.of(context).size.width * 0.2),
                child: new Container(
                  child: new Column(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: <Widget>[
                      for (var a = 0; a < 3; a++)
                        new Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: <Widget>[
                            for (var i = 1; i <= 3; i++)
                              if (a == 0)
                                new Padding(
                                    padding: EdgeInsets.all(
                                        MediaQuery.of(context).size.width *
                                            0.05),
                                    child: new FlatButton(
                                      onPressed: () => setCode(i),
                                      child: new Text(
                                        i.toString(),
                                        style: TextStyle(fontSize: 50.0),
                                      ),
                                    ))
                              else if (a == 1)
                                new Padding(
                                    padding: EdgeInsets.all(
                                        MediaQuery.of(context).size.width *
                                            0.05),
                                    child: new FlatButton(
                                      onPressed: () => setCode(i + 3),
                                      child: new Text(
                                        (i + 3).toString(),
                                        style: TextStyle(fontSize: 50.0),
                                      ),
                                    ))
                              else if (a == 2)
                                  new Padding(
                                      padding: EdgeInsets.all(
                                          MediaQuery.of(context).size.width *
                                              0.05),
                                      child: new FlatButton(
                                        onPressed: () => setCode(i + 6),
                                        child: new Text(
                                          (i + 6).toString(),
                                          style: TextStyle(fontSize: 50.0),
                                        ),
                                      ))
                          ],
                        ),
                      new Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: <Widget>[
                          new Padding(
                              padding: EdgeInsets.only(
                                  right: MediaQuery.of(context).size.width *
                                      0.21)),
                          new Padding(
                              padding: EdgeInsets.all(
                                  MediaQuery.of(context).size.width * 0.04),
                              child: new FlatButton(
                                onPressed: () => setCode(0),
                                child: new Text(
                                  '0',
                                  style: TextStyle(fontSize: 50.0),
                                ),
                              )),
                          new Padding(
                              padding: EdgeInsets.all(
                                  MediaQuery.of(context).size.width * 0.05),
                              child: new FlatButton(
                                  onPressed: () => setCode('remove'),
                                  child: new Icon(
                                    Icons.backspace,
                                    size: 50,
                                  )))
                        ],
                      )
                    ],
                  ),
                ),
              )
            ],
          )),
    );
  }

  @override
  Widget build(BuildContext context) {
    final double shortestSide = MediaQuery.of(context).size.shortestSide;
    final bool useMobileLayout = shortestSide < 600.0;
    final Orientation orientation = MediaQuery.of(context).orientation;
    return Scaffold(
        body: ModalProgressHUD(
          child: useMobileLayout
              ? gridviewForPhone(orientation)
              : gridviewForPhone(orientation),
          inAsyncCall: _saving,
        ));
  }

}

class CircleButton extends StatelessWidget {
  final GestureTapCallback onTap;

  const CircleButton({Key key, this.onTap, color}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    double size = 20.0;

    return new InkResponse(
      onTap: onTap,
      child: new Container(
        width: size,
        height: size,
        decoration: new BoxDecoration(
          color: Colors.white,
          shape: BoxShape.circle,
        ),
      ),
    );
  }
}
